# Required definitions for kernel module builds
LINUXKERNEL_CONFIG          = da850_omapl138_defconfig
LINUXKERNEL_INSTALL_DIR     = $(HOME)/workdir/omap-l138/kernel
UBOOT_CONFIG                = da850_omapl138_evm_config
UBOOT_INSTALL_DIR           = $(HOME)/workdir/omap-l138/uboot

# Required definitions for DSPLINK builds
DSPLINK_PLATFORM            = OMAPL138
DSPLINK_DSP_PROCESSOR       = OMAPL138GEM
GPPOS                       = ARM
DSPOS                       = DSPBIOS5XX
DSPLINK_CFG_OPTS            =--nodsp=1 --DspTskMode=1

# Architecture Specific Compiler flags
DSP_REGION_BASE_ADDR        ?= 0xC2000000
DSP_REGION_CMEM_SIZE        ?= 0x01000000
DSP_REGION_CODE_SIZE        ?= 0x01000000
PLATFORM_CFLAGS             = -DDSP_REGION_BASE_ADDR=$(DSP_REGION_BASE_ADDR) -DDSP_REGION_CMEM_SIZE=$(DSP_REGION_CMEM_SIZE) -DDSP_REGION_CODE_SIZE=$(DSP_REGION_CODE_SIZE)
ARM_CFLAGS                  = -mcpu=arm926ej-s -mlittle-endian -mfloat-abi=soft
DSP_CFLAGS                  = -mv6740
